//+------------------------------------------------------------------+
//|                                                EA_matryoshka.mq4 |
//|                                                              Oxy |
//|                                   http://oxy.opentraders.ru/bio/ |
//+------------------------------------------------------------------+
#property copyright "Oxy"
#property link      "http://oxy.opentraders.ru/bio/"
#property version   "1.00"
#property strict
//------- external parameters ---------------------------------------+
extern bool       TimeStartEnd      = false;                          //    
extern int        StartHour         = 9;                              //   
extern int        StartMin          = 30;                             //   
extern int        EndHour           = 23;                             //   
extern int        EndMin            = 30;                             //   
extern string     name3             = "__________";            //  
extern int        StepOrders        = 140;                            //  
extern double     Lot               = 0.1;                            // 
extern double     KoeffLot          = 1.4;                            //    , 0 - 
extern int        StopLoss          = 4000;                           // Stop Loss, 0 - 
extern double     CloseMoneyLoss    = 0;                              //      , 0 - 
extern int        TakeProfit        = 200;                            // Take Profit (!),  - 
extern double     CloseMoneyProfit  = 0;                              //      , 0 - 
extern int        DigitLot          = 2;                              //  : 1- 2 
extern int        MagicNumber       = 5775;                           // Magic
extern int        Slippage          = 30;                             // Slippage
extern int        NumberOfTry       = 5;                              // Number of try
//------- global variables ------------------------------------------+
string   nameEA = "matryoshka";
string   Symb;
datetime prevTime;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   Symb = Symbol();
   if(!IsTradeAllowed()) {Alert("  -!"); return(INIT_FAILED);}
   // --- 
   if(TimeStartEnd) {
     if(StartHour<0 || StartHour>23) { Alert("    !");       return(INIT_FAILED);}
     if(EndHour<0   || EndHour  >23) { Alert("    !");    return(INIT_FAILED);}
     if(StartMin<0  || StartMin >59) { Alert("    !");   return(INIT_FAILED);}
     if(EndMin<0    || EndMin   >59) { Alert("    !");return(INIT_FAILED);}
   }
   // ---
   if(Lot<MarketInfo(Symb, MODE_MINLOT) || Lot>MarketInfo(Symb, MODE_MAXLOT)) { Alert("  !");    return(INIT_FAILED);}
   
   double _mi_lv = MarketInfo(Symb, MODE_STOPLEVEL);
   //if(_mi_lv==0) _mi_lv = MarketInfo(Symb, MODE_SPREAD)*2;   
   if(StopLoss!=0   && StopLoss  <_mi_lv) {Alert("  Stop Loss!    : ", _mi_lv);   return(INIT_FAILED);}
   if(TakeProfit<_mi_lv) {Alert("  Take Profit!    : ", _mi_lv); return(INIT_FAILED);}
   if(CloseMoneyLoss<0 || CloseMoneyProfit<0)  {Alert("   /    0!"); return(INIT_FAILED);}
   // ---
   if(DigitLot!=1)      DigitLot=2;
   if(MagicNumber<0)    MagicNumber=1;
   if(Slippage<0)       Slippage=0;
   if(NumberOfTry<1)    NumberOfTry=1; 
   prevTime = LastTimeAnyOpenPosition(); 
   Comment("  ..."); 
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason){Comment("");}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
    if(!IsTradeAllowed()) {Comment("  -!"); return;}    
    string _txt="";
    if(TimeStartEnd) {
      _txt = "\n"+ " : " + (string)StartHour +":" +IntMinToString(StartMin) + " - " + (string)EndHour +":" + IntMinToString(EndMin) + "\n";      
    } 
    Comment(_txt);
    CheckDeletePendingOrder();
    if(CheckClosePosition()) return;    
    CheckPutGrid();
    CheckMoveTP();
    if(TimeStartEnd && !isTradeTimeInt(StartHour, StartMin, EndHour, EndMin)) return;
    if(prevTime != Time[0] && !HaveAnyOrder()) CheckPutPositionByPattern();
    prevTime = Time[0];  
  }
//+------------------------------------------------------------------+
void CheckPutGrid() {
  if(StepOrders<=0) return; 
  int _ticket=LastTicketOpenPosition(); if(_ticket==-1) return;
  if(!OrderSelect(_ticket, SELECT_BY_TICKET))return;
  double _lot = Lot;
  RefreshRates();
  if(OrderType()==OP_BUY) {
    if(OrderOpenPrice()-Ask>=StepOrders*Point) {
      if(KoeffLot>0) _lot = OrderLots()*KoeffLot;
      _lot=CheckLot(_lot); if(_lot==-1) return;  
      BuyPosition(_lot, StopLoss, 0, nameEA);
    }
  }
  if(OrderType()==OP_SELL){
    if(Bid-OrderOpenPrice()>=StepOrders*Point) {
      if(KoeffLot>0) _lot = OrderLots()*KoeffLot;
      _lot=CheckLot(_lot); if(_lot==-1) return;
      SellPosition(_lot, StopLoss, 0, nameEA);      
    }
  }
}
//+------------------------------------------------------------------+
void CheckPutPositionByPattern() {
  if(High[3]>High[2] && High[2]>High[1] && Low[3]<Low[2] && Low[2]<Low[1]) {
    double _bp = High[2];
    double _sp = Low[2];
    
    double _lot=CheckLot(Lot); if(_lot==-1) return;
    putOrderBuy_stepPoint(_bp, _lot, StopLoss, 0, nameEA);
    putOrderSell_stepPoint(_sp, _lot, StopLoss, 0, nameEA);
  }
}
//+------------------------------------------------------------------+
double CheckLot (double _lot) {
  double someLot = NormalizeDouble(_lot, DigitLot);
  if(_lot<MarketInfo(Symb, MODE_MINLOT)) someLot=MarketInfo(Symb, MODE_MINLOT);
  if(_lot>MarketInfo(Symb, MODE_MAXLOT)) someLot=MarketInfo(Symb, MODE_MAXLOT);  
  if(MarketInfo(Symb, MODE_MARGINREQUIRED)*_lot >= AccountFreeMargin()) someLot=-1;
  
  if(someLot==-1) Print("  !    ! ", _lot);
  return (someLot);
}
//+------------------------------------------------------------------+
int LastTicketOpenPosition() {
  int i, k = OrdersTotal ();
  datetime _time=-1;
  int   _ticket=-1;
  for (i=k-1; i>=0; i--) {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symb && OrderMagicNumber()==MagicNumber && (OrderType()==OP_BUY || OrderType()==OP_SELL)) {
        if(OrderOpenTime()>_time) {_time=OrderOpenTime(); _ticket=OrderTicket();}
      }
    }
  }
  return (_ticket);
}
//+------------------------------------------------------------------+
void CheckMoveTP() {
  int _type=TypeNOTtpOpenPosition(); if(_type==-1) return;
  if(_type==OP_BUY) {
    double zeroprice=ZeroPricePositions(OP_BUY); if(zeroprice==-1) return;
    double _price = NormalizeDouble(zeroprice+TakeProfit*Point, Digits);
    set_TP(OP_BUY, _price);
    return;
  }
  if(_type==OP_SELL) {
    double zeroprice=ZeroPricePositions(OP_SELL); if(zeroprice==-1) return;
    double _price = NormalizeDouble(zeroprice-TakeProfit*Point, Digits);
    set_TP(OP_SELL, _price);
  }
}
//+------------------------------------------------------------------+
double ZeroPricePositions (int type) {
  int i, k = OrdersTotal ();
  double lots=0;
  double sum=0;
  for (i=k-1; i>=0; i--) {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symb && OrderMagicNumber()==MagicNumber) {
        if(type==OrderType()) {
          sum      += OrderLots()*OrderOpenPrice();
          lots     += OrderLots();
        }
      }
    }
  }  
  if(lots==0) return(-1);
  double zeroprice=NormalizeDouble(sum/lots, Digits);
  return(zeroprice);
}
//+------------------------------------------------------------------+
void set_TP (int type, double new_TP) {
  int i, err, k = OrdersTotal ();
  for (i=k-1; i>=0; i--) {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (Symb==OrderSymbol() && OrderMagicNumber()==MagicNumber && type==OrderType()) {
        if(new_TP!= OrderTakeProfit()) {
          for (int it=1; it<=NumberOfTry; it++) {
            ResetLastError();
            if(!OrderModify(OrderTicket(), OrderOpenPrice(),  OrderStopLoss(), new_TP, 0)) {
              if(it>=NumberOfTry) { Print("Failed to change the order ", OrderTicket(), "! Number Of Try!"); break; }
              err=GetLastError();
              if (err==4 || err==6 || err==8 || err==128 || err==137 || err==141 || err==146) Sleep(1000*100);
              else { Print("Failed to change the order ", OrderTicket(), "! ", err); break; }          
            } else break;
          }        
        }
      }
    }
  }
}
//+------------------------------------------------------------------+
int TypeNOTtpOpenPosition() {
  int i, k = OrdersTotal ();
  for (i=k-1; i>=0; i--) {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symb && OrderMagicNumber()==MagicNumber) {
        if((OrderType()==0 || OrderType()==1) && OrderTakeProfit()==0) return (OrderType());
      }
    }
  }
  return (-1);
}
//+------------------------------------------------------------------+
void CheckDeletePendingOrder() {
  if(NumberOfPendingOrders()==1) DeletePendingPositions();
}
//+------------------------------------------------------------------+
bool HaveAnyOrder() {
  int i, k = OrdersTotal ();
  for (i=k-1; i>=0; i--) {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symb && OrderMagicNumber()==MagicNumber) {
        return (true);
      }
    }
  }
  return (false);
}
//+------------------------------------------------------------------+
int NumberOfPendingOrders(int or_tp=-1) {
  int i, k = OrdersTotal ();
  if(or_tp<2 || or_tp>5) or_tp=-1;
  int _num=0;
  for (i=k-1; i>=0; i--) {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symb && OrderMagicNumber()==MagicNumber) {
        if(or_tp==-1) {
          if (OrderType()>1 && OrderType()<6) _num++;
        } else {
          if(or_tp==OrderType()) _num++;
        }
      }
    }
  }
  return (_num);
}
//+------------------------------------------------------------------+
bool CheckClosePosition() {
  if(CloseMoneyLoss>0)   {
    if(ProfitSummOrders()<=CloseMoneyLoss*-1) {
      CloseOpenPositions();
      return(true);
    }
  }
  if(CloseMoneyProfit>0) {
    if(ProfitSummOrders()>=CloseMoneyProfit) {
      CloseOpenPositions();
      return(true);
    }
  }
  return(false);
}
//+------------------------------------------------------------------+
double ProfitSummOrders(int or_tp=-1) {
  int i, ot, k = OrdersTotal ();
  if(or_tp<0 || or_tp>1) or_tp=-1;
  double _profit=0;
  for (i=k-1; i>=0; i--) {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symb && OrderMagicNumber()==MagicNumber) {
        ot=OrderType();
        if((or_tp==-1 && (ot==0 || ot==1)) || or_tp==ot) 
          _profit += OrderProfit()+OrderCommission()+OrderSwap();
      }
    }
  }
  return (_profit);
}
//+------------------------------------------------------------------+
datetime LastTimeAnyOpenPosition() {
  int i, k = OrdersTotal ();
  datetime _time=-1;
  for (i=k-1; i>=0; i--) {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symb && OrderMagicNumber()==MagicNumber) {
        if(OrderOpenTime()>_time) _time=OrderOpenTime();
      }
    }
  }
  return (_time);
}
//+------------------------------------------------------------------+
//| BUY                                                              |
//+------------------------------------------------------------------+
bool BuyPosition(double _lot, int _sl=0, int _tp=0, string _comment=NULL) {
  double sl=0,tp=0,_mi_lv;
  
  int err;
  for (int it=1; it<=NumberOfTry; it++) {
    _mi_lv = MarketInfo(Symb, MODE_STOPLEVEL);
    if(_mi_lv==0) _mi_lv = MarketInfo(Symb, MODE_SPREAD)*2;
    ResetLastError();
    RefreshRates(); 
    if(_sl>0) { sl=Ask-(double)_sl*Point; if(Bid-sl<_mi_lv*Point) sl=Bid-_mi_lv*Point; }
    if(_tp>0)   tp=Ask+(double)_tp*Point; 
    if (OrderSend(Symb, OP_BUY, _lot, NormalizeDouble(Ask,Digits), Slippage, NormalizeDouble(sl,Digits), NormalizeDouble(tp,Digits), _comment, MagicNumber)==-1) {
      if(it>=NumberOfTry) { Print("Failed OP_BUY ! ", "Number Of Try!"); return(false); }
      err=GetLastError();
      if (err==4 || err==6 || err==8 || err==128 || err==137 || err==141 || err==146) Sleep(1000*100);
      else { Print("Failed OP_BUY ! ", err); return(false); }
    } else break;
  }
  return(true);
}
//+------------------------------------------------------------------+
//| SELL                                                             |
//+------------------------------------------------------------------+
bool SellPosition(double _lot, int _sl=0, int _tp=0, string _comment=NULL) {
  double sl=0,tp=0,_mi_lv;
  
  int err;
  for (int it=1; it<=NumberOfTry; it++) {
    _mi_lv = MarketInfo(Symb, MODE_STOPLEVEL);
    if(_mi_lv==0) _mi_lv = MarketInfo(Symb, MODE_SPREAD)*2;
    ResetLastError();
    RefreshRates();
    if(_sl>0) { sl=Bid+(double)_sl*Point; if(sl-Ask<_mi_lv*Point) sl=Ask+_mi_lv*Point; }
    if(_tp>0)   tp=Bid-(double)_tp*Point;
    if (OrderSend(Symb, OP_SELL, _lot, NormalizeDouble(Bid,Digits), Slippage, NormalizeDouble(sl,Digits), NormalizeDouble(tp,Digits), _comment, MagicNumber)==-1) {
      if(it>=NumberOfTry) { Print("Failed OP_SELL ! ", "Number Of Try!"); return(false); }
      err=GetLastError();
      if (err==4 || err==6 || err==8 || err==128 || err==137 || err==141 || err==146) Sleep(1000*100);
      else { Print("Failed OP_SELL ! ", err); return(false); }
    } else break;
  }
  return(true);
}
//+------------------------------------------------------------------+
double putOrderBuy_stepPoint(double _price, double _lot, int _sl=0, int _tp=0, string _comment=NULL, int _hour_expiration=0) {
  datetime _expiration = 0;
  if(_hour_expiration>0) _expiration =  TimeCurrent()+3600*_hour_expiration;
  int err;
  double sl=0,tp=0;
  int _mi_lv = (int)MarketInfo(Symb, MODE_STOPLEVEL);
  if(_mi_lv==0) _mi_lv = 2;
  
  RefreshRates();
  double ask_price = Ask;
  if(_price<ask_price+_mi_lv*Point) _price=ask_price+_mi_lv*Point;
  
  if(_sl>0) {
    if(_sl<_mi_lv) _sl=_mi_lv;
    sl=_price-(double)_sl*Point;
  }
  if(_tp>0) {
    if(_tp<_mi_lv) _tp=_mi_lv;
    tp=_price+(double)_tp*Point;
  }  
  _lot= NormalizeDouble(_lot, DigitLot);
  _price = NormalizeDouble(_price,Digits);
  sl = NormalizeDouble(sl,Digits);
  tp = NormalizeDouble(tp,Digits);
  ResetLastError(); 
  if (_price>ask_price) {     
    if (OrderSend(Symb, OP_BUYSTOP, _lot,  _price, Slippage, sl, tp, _comment, MagicNumber, _expiration)==-1) 
      { err=GetLastError(); Print("    BUYSTOP! : ",_lot," : ", _price, " Ask: ", ask_price, " SL: ", sl, " TP: ", tp, " error: ", err);  return (false);}
  }
  return (_price);
}
double putOrderSell_stepPoint(double _price, double _lot, int _sl=0, int _tp=0, string _comment=NULL, int _hour_expiration=0) {
  datetime _expiration = 0;
  if(_hour_expiration>0) _expiration =  TimeCurrent()+3600*_hour_expiration;
  int err;
  double sl=0,tp=0;
  int _mi_lv = (int)MarketInfo(Symb, MODE_STOPLEVEL);
  if(_mi_lv==0) _mi_lv = 2;
  
  RefreshRates();
  double bid_price = Bid;
  if(_price>bid_price-_mi_lv*Point) _price=bid_price-_mi_lv*Point;
  
  if(_sl>0) {
    if(_sl<_mi_lv) _sl=_mi_lv;
    if(_sl>0) sl=_price+(double)_sl*Point;
  }
  if(_tp>0) {
    if(_tp<_mi_lv) _tp=_mi_lv;
    if(_tp>0) tp=_price-(double)_tp*Point;
  } 
  _lot= NormalizeDouble(_lot, DigitLot);
  _price = NormalizeDouble(_price,Digits);
  sl = NormalizeDouble(sl,Digits);
  tp = NormalizeDouble(tp,Digits); 
  ResetLastError();  
  if (_price<bid_price) {
    if (OrderSend(Symb, OP_SELLSTOP, _lot,  _price, Slippage, sl, tp, _comment, MagicNumber, _expiration)==-1) 
      { err=GetLastError(); Print("    SELLSTOP! : ",_lot," : ", _price, " Bid: ", bid_price, " SL: ", sl, " TP: ", tp, " error: ", err);  return (false);}
  }   
  return (_price);
}
//+------------------------------------------------------------------+
//| Delete pending positions                                         |
//+------------------------------------------------------------------+
void DeletePendingPositions (int or_tp=-1) {   
  int i, err, k=OrdersTotal(), ot;
  if(or_tp<2 || or_tp>5) or_tp=-1;
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {      
      if (OrderSymbol()==Symb && OrderMagicNumber()==MagicNumber) {
        ot = OrderType();
        if((or_tp==-1 && (ot>1 && ot<6)) || or_tp==ot) {
          for (int it=1; it<=NumberOfTry; it++) {
            int _ticket = OrderTicket();
            ResetLastError();    
            if (!OrderDelete(_ticket)) {      
              if(it>=NumberOfTry) { Print("Failed to delete the order ", _ticket, "! Number Of Try!"); break; }
              err=GetLastError();
              if (err==4 || err==6 || err==8 || err==128 || err==137 || err==141 || err==146) Sleep(1000*100);
              else { Print("Failed to delete the order ", _ticket, "! ", err); break; } 
            } else break;
          }
        }
      }
    }
  }
}
//+------------------------------------------------------------------+
//| Close open positions                                             |
//+------------------------------------------------------------------+
void CloseOpenPositions (int or_tp=-1) {
  int i, err, k=OrdersTotal(), ot;
  if(or_tp<0 || or_tp>1) or_tp=-1;
  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {      
      if (OrderSymbol()==Symb && OrderMagicNumber()==MagicNumber) {
        ot = OrderType();
        if((or_tp==-1 && (ot==0 || ot==1)) || or_tp==ot) {
          for (int it=1; it<=NumberOfTry; it++) {
            ResetLastError();
            RefreshRates();
            double _price=Ask; if(ot==0) _price=Bid;

            if (!OrderClose(OrderTicket(), OrderLots(), _price, Slippage)) {
              if(it>=NumberOfTry) { Print("Failed to close the order ", OrderTicket(), "! Number Of Try!"); break; }
              err=GetLastError();
              if (err==4 || err==6 || err==8 || err==128 || err==137 || err==141 || err==146) Sleep(1000*100);
              else { Print("Failed to close the order ", OrderTicket(), "! ", err); break; } 
            } else break;            
          }
        }        
      }
    }
  }
}
//+------------------------------------------------------------------+
//|   :      .      |
//+------------------------------------------------------------------+
//|  :                                                      |
//|    hb -                                 |
//|    mb -                               |
//|    he -                              |
//|    me -                            |
//+------------------------------------------------------------------+
bool isTradeTimeInt(int hb=0,int mb=0,int he=0,int me=0)
  {
   datetime db, de;           //     
   int      hc;               //     

   db=StrToTime(TimeToStr(TimeCurrent(), TIME_DATE)+" "+IntegerToString(hb)+":"+IntegerToString(mb));
   de=StrToTime(TimeToStr(TimeCurrent(), TIME_DATE)+" "+IntegerToString(he)+":"+IntegerToString(me));
   hc=TimeHour(TimeCurrent());

   if(db>=de)
     {
      if(hc>=he) de+=24*60*60; else db-=24*60*60;
     }

   if(TimeCurrent()>=db && TimeCurrent()<de) return(true);
   return(false);
  }
//+------------------------------------------------------------------+
string IntMinToString (int _min) {
  string _txt = (string)_min;
  if(_min<10) _txt = "0" + (string)_min;
  return (_txt); 
}
//+------------------------------------------------------------------+